"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class Geometry(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _GeometryStatus:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _GeometryStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Geometry._GeometryStatus.ValueType], builtins.type):  # noqa: F821
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        GEOMETRY_STATUS_UNSPECIFIED: Geometry._GeometryStatus.ValueType  # 0
        """A well-formed geometry resource will never have this value."""
        GEOMETRY_STATUS_NOT_READY: Geometry._GeometryStatus.ValueType  # 1
        """Geometry is not ready for use, an operation to create or modify the
        geometry is ongoing.
        """
        GEOMETRY_STATUS_READY: Geometry._GeometryStatus.ValueType  # 2
        """Geometry is ready for use."""
        GEOMETRY_STATUS_FAILED: Geometry._GeometryStatus.ValueType  # 3
        """Geometry was not created successfully and is unusable."""

    class GeometryStatus(_GeometryStatus, metaclass=_GeometryStatusEnumTypeWrapper): ...
    GEOMETRY_STATUS_UNSPECIFIED: Geometry.GeometryStatus.ValueType  # 0
    """A well-formed geometry resource will never have this value."""
    GEOMETRY_STATUS_NOT_READY: Geometry.GeometryStatus.ValueType  # 1
    """Geometry is not ready for use, an operation to create or modify the
    geometry is ongoing.
    """
    GEOMETRY_STATUS_READY: Geometry.GeometryStatus.ValueType  # 2
    """Geometry is ready for use."""
    GEOMETRY_STATUS_FAILED: Geometry.GeometryStatus.ValueType  # 3
    """Geometry was not created successfully and is unusable."""

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PROJECT_ID_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    CREATE_TIME_FIELD_NUMBER: builtins.int
    UPDATE_TIME_FIELD_NUMBER: builtins.int
    INTERNAL_GEOMETRY_URL_FIELD_NUMBER: builtins.int
    id: builtins.str
    """The unique identifier for the geometry."""
    name: builtins.str
    """User specified geometry name, does not need to be unique. Maximum
    allowed length is 256 characters.
    """
    project_id: builtins.str
    """The ID of the project this geometry belongs to."""
    status: global___Geometry.GeometryStatus.ValueType
    """Output only. The current status of the geometry."""
    @property
    def create_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output only. The timestamp when the geometry was created."""
    @property
    def update_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output only. The timestamp when the geometry was last updated."""
    internal_geometry_url: builtins.str
    """INTERNAL ONLY. REMOVE BEFORE EXTERNAL API RELEASE.
    The url used to visualize this geometry.
    """
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        project_id: builtins.str = ...,
        status: global___Geometry.GeometryStatus.ValueType = ...,
        create_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        update_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        internal_geometry_url: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["create_time", b"create_time", "update_time", b"update_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["create_time", b"create_time", "id", b"id", "internal_geometry_url", b"internal_geometry_url", "name", b"name", "project_id", b"project_id", "status", b"status", "update_time", b"update_time"]) -> None: ...

global___Geometry = Geometry

class GetGeometryRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. Identifies the geometry to retrieve."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___GetGeometryRequest = GetGeometryRequest

class GetGeometryResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GEOMETRY_FIELD_NUMBER: builtins.int
    @property
    def geometry(self) -> global___Geometry:
        """The requested geometry."""
    def __init__(
        self,
        *,
        geometry: global___Geometry | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["geometry", b"geometry"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["geometry", b"geometry"]) -> None: ...

global___GetGeometryResponse = GetGeometryResponse

class ListGeometriesRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROJECT_ID_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. The project to list geometries for."""
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["project_id", b"project_id"]) -> None: ...

global___ListGeometriesRequest = ListGeometriesRequest

class ListGeometriesResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    GEOMETRIES_FIELD_NUMBER: builtins.int
    @property
    def geometries(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Geometry]:
        """The list of geometries belonging to the specified project. Order of
        geometries is unspecified.
        """
    def __init__(
        self,
        *,
        geometries: collections.abc.Iterable[global___Geometry] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["geometries", b"geometries"]) -> None: ...

global___ListGeometriesResponse = ListGeometriesResponse
